Loading...
Searching...
No Matches
Qore::ObjectReverseIterator Class Reference

This class an iterator class for objects. More...

`#include <QC_ObjectReverseIterator.dox.h>`

Inheritance diagram for Qore::ObjectReverseIterator:
[legend]

## Public Member Functions

| constructor (object o)
| Creates the object iterator object.
| constructor ()
| Creates an empty iterator object.
| copy ()
| Creates a copy of the ObjectReverseIterator object, iterating the same object as the original and in the same position.
bool | first ()
| returns True if on the last element of the object
bool | last ()
| returns True if on the first element of the object
bool | next ()
| Moves the current position to the previous element in the object; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the object if the object is not empty.
bool | prev ()
| Moves the current position to the next element in the object; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the object if the object is not empty.
Public Member Functions inherited from Qore::ObjectIterator
| constructor (object o)
| Creates the object iterator object.
| constructor ()
| Creates an empty object iterator object.
| copy ()
| Creates a copy of the ObjectIterator object, iterating the same object as the original and in the same position.
Public Member Functions inherited from Qore::HashIterator
| constructor (hash< auto > h)
| Creates the hash iterator object.
| constructor ()
| Creates an empty hash iterator object.
| copy ()
| Creates a copy of the HashIterator object, iterating the same object as the original and in the same position.
bool | empty ()
| returns True if the hash is empty; False if not
bool | first ()
| returns True if on the first element of the hash
string | getKey ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid
auto | getKeyValue ()
| returns the current value of the current hash key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid
auto | getValue ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid
hash< auto > | getValuePair ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid
bool | last ()
| returns True if on the last element of the hash
bool | next ()
| Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty.
bool | prev ()
| Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty.
| reset ()
| Reset the iterator instance to its initial state.
bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not
abstract bool | prev ()
| Moves the current position to the previous element; returns False if there are no more elements.
abstract auto | getValue ()
| returns the current value
abstract bool | next ()
| Moves the current position to the next element; returns False if there are no more elements.
abstract bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not
abstract bool | empty ()
| returns True if the object to iterate is empty; False if not
abstract bool | first ()
| returns True if on the first element
abstract bool | last ()
| returns True if on the last element

## Detailed Description

This class an iterator class for objects.

Call ObjectReverseIterator::next() to iterate through the object in reverse order; do not use the iterator if ObjectReverseIterator::next() returns False. An object can be iterated in reverse order by calling ObjectReverseIterator::prev() instead of ObjectReverseIterator::next()

Example: ObjectReverseIterator basic usage
  class Class1 {
  public {
  int attr1;
  date attr2;
  }
  constructor() {
  attr1 = 1;
  attr2 = now();
  }
  }
  Class1 o();
  ObjectReverseIterator it(o);
  while (it.next()) {
  printf("iter: %n\n", it.getValue());
  }
  iter: 2013-04-17 16:31:03 Wed +02:00 (CEST)
  iter: 1

Note
  - In general, the ObjectReverseIterator class is not designed to be accessed from multiple threads; it was created without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause an `ITERATOR-THREAD-ERROR` to be thrown.
  - ObjectReverseIterator is functionally equivalent to ObjectIterator, but the effect of ObjectReverseIterator::next() and ObjectReverseIterator::prev() are the opposite of ObjectIterator::next() and ObjectIterator::prev(); that is ObjectReverseIterator::next() will iterate through the object in reverse order, while ObjectReverseIterator::prev() iterates in forward order. Additionally the meanings of the return values for ObjectReverseIterator::first() and ObjectReverseIterator::last() are swapped in respect to ObjectIterator::first() and ObjectIterator::last().

See also
  ObjectIterator

## Member Function Documentation

## constructor() [1/2]

Qore::ObjectReverseIterator::constructor | ( |  | ) |

Creates an empty iterator object.

Example:
  *object obj = get_object_or_nothing();
  ObjectReverseIterator i(obj);

## constructor() [2/2]

Qore::ObjectReverseIterator::constructor | ( | object | o | ) |

Creates the object iterator object.

Parameters

  o | the object to iterate

Example:
  ObjectReverseIterator i(obj);

## copy()

Qore::ObjectReverseIterator::copy | ( |  | ) |

Creates a copy of the ObjectReverseIterator object, iterating the same object as the original and in the same position.

Example:
  ObjectReverseIterator ni = i.copy();

## first()

bool Qore::ObjectReverseIterator::first | ( |  | ) |

virtual

returns True if on the last element of the object

Returns
  True if on the last element of the object

Code Flags:
  CONSTANT

Example:
  while (i.next()) {
  if (i.first())
  printf("START:\n");
  }

Reimplemented from Qore::HashIterator.

## last()

bool Qore::ObjectReverseIterator::last | ( |  | ) |

virtual

returns True if on the first element of the object

Returns
  True if on the first element of the object

Code Flags:
  CONSTANT

Example:
  while (i.next()) {
  if (i.last())
  printf("END.\n");
  }

Reimplemented from Qore::HashIterator.

## next()

bool Qore::ObjectReverseIterator::next | ( |  | ) |

virtual

Moves the current position to the previous element in the object; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the object if the object is not empty.

This method will return True again after it returns False once if the object is not empty, otherwise it will always return False. The iterator object should not be used after this method returns False

Returns
  False if there are no more elements in the object (in which case the iterator object is invalid and should not be used); True if successful (meaning that the iterator object is valid)

Example:
  while (i.prev()) {
  printf(" + %y\n", i.getValue());
  }

Note
  ObjectReverseIterator::next() is the opposite of ObjectIterator::next(); it is functionally equivalent to ObjectIterator::prev(); ObjectReverseIterator::next() iterates through the object in reverse order

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Reimplemented from Qore::HashIterator.

## prev()

bool Qore::ObjectReverseIterator::prev | ( |  | ) |

virtual

Moves the current position to the next element in the object; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the object if the object is not empty.

This method will return True again after it returns False once if object is not empty, otherwise it will always return False. The iterator object should not be used after this method returns False

Returns
  False if there are no more elements in the object (in which case the iterator object is invalid and should not be used); True if successful (meaning that the iterator object is valid)

Example:
  while (i.next()) {
  printf(" + %y\n", i.getValue());
  }

Note
  ObjectReverseIterator::prev() is the opposite of ObjectIterator::prev(); it is functionally equivalent to ObjectIterator::next(); ObjectReverseIterator::prev() iterates through the object in forward order

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Reimplemented from Qore::HashIterator.